import x10.compiler.Native;

public class pArms {

    @Native("c++",
	    "void initParams_stub(long *);\n" +
	    "long p; \n" +
	    "initParams_stub(&p);\n" +
	    "*(#1->raw()) = p;")
	static native def _initParams(m:Rail[int]{self.length==1}):void;
    
    @Native("c++",
	    "void readSystem_stub(long *, long *, long);\n" +
	    "long A, b; \n" +
	    "readSystem_stub(&A, &b, #2);\n" +
	    "(#1->raw())[0] = A;\n" +
	    "(#1->raw())[1] = b;")
	static native def _readSystem(m:Rail[int]{self.length==2}, n:int):void;
    
    @Native("c++",
	    "void initSolution_stub(long *, long);\n" +
	    "long x; \n" +
	    "initSolution_stub(&x, #2);\n" +
	    "*(#1->raw()) = x;")
	static native def _initSolution(p_x:Rail[int]{self.length==1}, m:int):void;
    
    @Native("c++",
	    "void ResiNorm2_stub(double *, long, long , long);\n" +
	    "double r; \n" +
	    "ResiNorm2_stub(&r, #2,  #3, #4);\n" +
	    "*(#1->raw()) = r;")
	static native def _ResiNorm2(p_r:Rail[double]{self.length==1}, 
				     A:int, b:int, x:int):void;
    @Native("c++",
	    "void CreatePrec_stub(long *, long, long);\n" +
	    "long r; \n" +
	    "CreatePrec_stub(&r, #2,  #3);\n" +
	    "*(#1->raw()) = r;")
	static native def _createPrec(r:Rail[int]{self.length==1}, 
				      A:int, p:int):void;

    @Native("c++",
	    "void FGMRESD_stub(long A, long Prec, long prm, long B, long X);\n" +
	    "FGMRESD_stub(#1, #2, #3, #4, #5);\n")
	static native def _FGMRESD(A:int, prec:int, p:int, b:int, x:int):void;

    @Native("c++",
	    "void finalize_stub();\n" +
	    "finalize_stub();\n")
	static native def _finalize():void;

    @Native("c++",
	    "void initialize_stub();\n" +
	    "initialize_stub();\n")
	static native def _initialize():void;


    static public def initParams() : int {
	var p_params : Rail[int]{self.length==1} = Rail.makeVar[int](1);
	_initParams(p_params);
	return p_params(0);
    }
    
    static public def readSystem(params:int) : Rail[int]{self.length==2} {
	var s : Rail[int]{self.length==2} = Rail.makeVar[int](2);
	_readSystem(s, params);
	return s;
    }
    
    static public def initSolution(m:int) : int {
	var p_x : Rail[int]{self.length==1} = Rail.makeVar[int](1);
	_initSolution(p_x, m);
	return p_x(0);
    }

    static public def ResiNorm2(m:int, b:int, x:int) : double {
	var p_r : Rail[double]{self.length==1} = Rail.makeVar[double](1);
	_ResiNorm2(p_r, m, b, x);
	return p_r(0);
    }

    static public def createPrec(m:int, p:int) : int {
	var p_pr : Rail[int]{self.length==1} = Rail.makeVar[int](1);
	_createPrec(p_pr, m, p);
	return p_pr(0);
    }

    static public def FGMRESD(m:int, prec:int, p:int, b:int, x:int) : void {
	_FGMRESD(m, prec, p, b, x);
    }
    
    static public def initialize() : void {
	_initialize();
    }

    static public def finalize() : void {
	_finalize();
    }
};
