#include "psparslib.h"
#include "generaldefs.h"
#include "pArmsC.h"

void readSystemC(long *p_m, long *p_v, long p)
{
  Params _p = (Params) p;
  DistMatrix _m ;
  Vec _v;
  readSystem(_p, &_m, &_v);
  *p_m = (long) _m;
  *p_v = (long) _v;
}

void initParamsC(long *p_p)
{
  Params p = params("input");
  *p_p = (long) p;
}


#include "mpi.h"

static int MPI_already;

void initializeC()
{
    MPI_Initialized(&MPI_already); 

    if (!MPI_already) {
       int argc = 0, provided;
       char **argv = NULL;
       MPI_Init_thread(&argc, &argv, MPI_THREAD_MULTIPLE, &provided);
       if (provided != MPI_THREAD_MULTIPLE) {
 	  MPI_Finalize();
          fprintf(stderr, "MPI threads level is not MPI_THREAD_MULTIPLE\n");
          exit(-1);
       }
    }
}

void finalizeC()
{
    if (!MPI_already)
       MPI_Finalize();
}

void FGMRESDC(long m, long prec, long p, long b, long x)
{
  Params _p = (Params) p;
  DistMatrix _m = (DistMatrix) m;
  PreCon _prec = (PreCon) prec;

  Vec _b = (Vec) b;
  Vec _x = (Vec) x;

  fgmresd(_m, _prec, _p->ipar, _b, _x);
}

void CreatePrecC(long*p_pr, long m, long p)
{
  Params _p = (Params) p;
  DistMatrix _m = (DistMatrix) m;
  PreCon _prec;

  CreatePrec(_m, &_prec, _p->method, _p->prepar, _p->ipar);

  *p_pr = (long) _prec;
}

void ResiNorm2C(double*p_r, long m, long b, long x)
{
  DistMatrix _m = (DistMatrix) m;
  Vec _b = (Vec) b;
  Vec _x = (Vec) x;

  *p_r = ResiNorm2(_m, _b, _x);
}

void initSolutionC(long*p_x, long m)
{
  DistMatrix _m = (DistMatrix) m;

  *p_x = (long) initSolution(_m);
}

